## pycurl 7.45.4

=== debian/changelog ===
pycurl (7.45.4-1build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 22:48:51 +0000

pycurl (7.45.4-1) unstable; urgency=medium

  * Update to new upstream release 7.45.4
  * Update Standards-Version to 4.7.0
  * Switch back to building with GnuTLS (Closes: #1070917)

 -- Scott Talbert <swt@techie.net>  Fri, 13 Dec 2024 20:47:24 -0500

pycurl (7.45.3-3) unstable; urgency=medium

  [ Matthias Klose ]
  * Also fix autopkg test dependencies.

  [ Scott Talbert ]
  * Fix segfault when running multi_tests (Closes: #1084321)

 -- Scott Talbert <swt@techie.net>  Fri, 22 Nov 2024 18:26:47 -0500

pycurl (7.45.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Run tests with flask instead of bottle, patch taken from upstream.
    Closes: #1085878.

 -- Matthias Klose <doko@debian.org>  Tue, 19 Nov 2024 18:38:22 +0100

=== debian/control ===
Source: pycurl
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Scott Talbert <swt@techie.net>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               libcurl4-gnutls-dev,
               libgnutls28-dev,
               libpython3-all-dev,
               libssh2-1-dev,
               python3-all-dev:any,
               python3-flask <!nocheck>,
               python3-flaky <!nocheck>,
               python3-pyflakes <!nocheck>,
               python3-pytest <!nocheck>,
               python3-setuptools,
               vsftpd <!nocheck>,
Build-Depends-Indep: dh-sequence-sphinxdoc,
                     python3-sphinx,
Standards-Version: 4.7.0
X-Python-Version: all
Homepage: http://pycurl.sourceforge.net
Vcs-Git: https://salsa.debian.org/python-team/packages/pycurl.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/pycurl
Rules-Requires-Root: no

Package: python3-pycurl
Architecture: any
Suggests: libcurl4-gnutls-dev,
          python-pycurl-doc,
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Description: Python bindings to libcurl (Python 3)
 This module provides the Python bindings to libcurl. Please refer to
 the libcurl documentation available in libcurl4-gnutls-dev Debian package.
 .
 NOTE: the SSL support is provided by GnuTLS.
 .
 This package contains PyCURL for Python 3.

Package: python-pycurl-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
Multi-Arch: foreign
Description: Python bindings to libcurl (documentation)
 This module provides the Python bindings to libcurl. Please refer to
 the libcurl documentation available in libcurl4-gnutls-dev Debian package.
 .
 NOTE: the SSL support is provided by GnuTLS.
 .
 This package contains the PyCURL documentation.

=== debian/rules ===
#! /usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

include /usr/share/dpkg/architecture.mk

PY3VERS := $(shell py3versions -vs)
CURLVERS := $(strip $(shell /usr/bin/curl-config --version | awk '{print $$2}'))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DO_PACKAGES = $(shell dh_listpackages)

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__$(DEB_HOST_MULTIARCH)
endif

%:
	dh $@

override_dh_auto_build:
	$(MAKE) gen PYTHON=python3
	for py in $(PY3VERS) ; do \
		python$$py setup.py build ; \
	done
	mkdir -p www/htdocs/doc
ifneq (,$(filter python-pycurl-doc,$(DO_PACKAGES)))
	$(MAKE) docs PYTHON=python3
endif

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	set -e ;\
	for py in $(PY3VERS) ; do \
		make do-test PYTHON=python$$py PYTEST="python$$py -m pytest" PYTEST_ADDOPTS="--ignore examples --ignore .pc -m 'not online'" PYFLAKES="python$$py -m pyflakes" PYCURL_VSFTPD_PATH=vsftpd; \
	done
endif

override_dh_auto_install:
	for py in $(PY3VERS); do \
		python$$py setup.py install --root=$(CURDIR)/debian/python3-pycurl --install-layout=deb; \
	done

	# Remove documentation as installed by setup.py
	rm -rf $(CURDIR)/debian/python*-pycurl*/usr/share/doc/pycurl

override_dh_installdocs:
	mkdir -p debian/python-pycurl-doc/usr/share/doc/python-pycurl-doc/html
ifneq (,$(filter python-pycurl-doc,$(DO_PACKAGES)))
	cp -a build/doc/* $(CURDIR)/debian/python-pycurl-doc/usr/share/doc/python-pycurl-doc/html
endif
	dh_installdocs -ppython3-pycurl --link-doc=python3-pycurl
	dh_installdocs -Npython3-pycurl

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_strip:
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	dh_strip -ppython3-pycurl --dbgsym-migration='python3-pycurl-dbg (<< 7.44.1-2~)'
endif

override_dh_compress:
	dh_compress -X.py

override_dh_shlibdeps:
	dh_shlibdeps -a
	sed -i '/shlibs:Depends/s,\(libcurl[0-9]*t64-gnutls (>= \)[^)]*\().*\),\1$(CURLVERS)\2,' debian/python3-pycurl*.substvars

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/pycurl/pycurl-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## pycurl 7.45.6

=== tests/fake-curl/libcurl/Makefile ===
ALL = \
	with_gnutls.so \
	with_nss.so \
	with_openssl.so \
	with_unknown_ssl.so \
	without_ssl.so

all: $(ALL)
clean:
	rm -f $(ALL)

.SUFFIXES: .c .so

CC = `curl-config --cc`
CFLAGS += `curl-config --cflags`
UNAME := $(shell uname -s)
ifeq ($(UNAME),Darwin)
	SONAME_FLAG = -install_name
else
	SONAME_FLAG = -soname
endif

.c.so:
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -shared -fPIC \
		-Wl,$(SONAME_FLAG),$@ -o $@ $<

show-targets:
	ls *c |sed -e 's/.c$$/.so/' | awk '{print $$1 " \\"}'

=== debian/changelog ===
pycurl (7.45.6-3) unstable; urgency=medium

  * Handle -rc versions of curl (Closes: #1112680)

 -- Scott Talbert <swt@techie.net>  Mon, 01 Sep 2025 14:35:03 -0400

pycurl (7.45.6-2) unstable; urgency=medium

  [ Carlos Henrique Lima Melara ]
  * d/p/tests-handle-change-in-debug-output-in-curl-8.16.0.patch: add patch.

 -- Scott Talbert <swt@techie.net>  Sun, 31 Aug 2025 09:18:02 -0400

pycurl (7.45.6-1) unstable; urgency=medium

  * Team upload.
  * [68f4477] New upstream version 7.45.6
  * [7bae5dd] Update Standards-Version to 4.7.2

 -- Kathara Sasikumar <katharasasikumar007@gmail.com>  Tue, 15 Apr 2025 15:52:26 +0530

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 include /usr/share/dpkg/architecture.mk
 
 PY3VERS := $(shell py3versions -vs)
-CURLVERS := $(strip $(shell /usr/bin/curl-config --version | awk '{print $$2}'))
+CURLVERS := $(strip $(shell /usr/bin/curl-config --version | awk '{print $$2}' | sed 's/-rc/~rc/'))
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all

## pycurl 7.45.7

=== Makefile ===
#
# to use a specific python version call
#   `make PYTHON=python2.7'
#

SHELL = /bin/sh

PYTHON = python
PYTEST = pytest
PYFLAKES = pyflakes

PYTHONMAJOR=$$($(PYTHON) -V 2>&1 |awk '{print $$2}' |awk -F. '{print $$1}')
PYTHONMINOR=$$($(PYTHON) -V 2>&1 |awk '{print $$2}' |awk -F. '{print $$2}')

# -c on linux
# freebsd does not understand -c
CHMOD_VERBOSE=-v

BUILD_WWW = build/www

RSYNC = rsync
##RSYNC_FLAGS = -av --relative -e ssh
RSYNC_FLAGS = -av --relative --delete --delete-after -e ssh

RSYNC_FILES = \
	htdocs \
	htdocs/download/.htaccess \
	upload

RSYNC_EXCLUDES = \
	'--exclude=htdocs/download/' \
	'--exclude=upload/Ignore/' \
	'--exclude=htdocs/travis-deps/'

RSYNC_TARGET = /home/groups/p/py/pycurl/

RSYNC_USER = armco@web.sourceforge.net

# src/module.c is first because it declares global variables
# which other files reference; important for single source build
SOURCES = src/easy.c src/easycb.c src/easyinfo.c src/easyopt.c src/easyperform.c \
	src/module.c src/multi.c src/oscompat.c src/pythoncompat.c \
	src/share.c src/stringcompat.c src/threadsupport.c src/util.c

GEN_SOURCES = src/docstrings.c src/docstrings.h

ALL_SOURCES = src/pycurl.h $(GEN_SOURCES) $(SOURCES)

RELEASE_SOURCES = src/allpycurl.c

DOCSTRINGS_SOURCES = \
	doc/docstrings/curl.rst \
	doc/docstrings/curl_close.rst \
	doc/docstrings/curl_errstr.rst \
	doc/docstrings/curl_errstr_raw.rst \
	doc/docstrings/curl_getinfo.rst \
	doc/docstrings/curl_getinfo_raw.rst \
	doc/docstrings/curl_pause.rst \
	doc/docstrings/curl_perform.rst \
	doc/docstrings/curl_reset.rst \
	doc/docstrings/curl_setopt.rst \
	doc/docstrings/curl_unsetopt.rst \
	doc/docstrings/curl_set_ca_certs.rst \
	doc/docstrings/multi.rst \
	doc/docstrings/multi_add_handle.rst \
	doc/docstrings/multi_assign.rst \
	doc/docstrings/multi_close.rst \
	doc/docstrings/multi_fdset.rst \
	doc/docstrings/multi_info_read.rst \
	doc/docstrings/multi_perform.rst \
	doc/docstrings/multi_remove_handle.rst \
	doc/docstrings/multi_select.rst \
	doc/docstrings/multi_setopt.rst \
	doc/docstrings/multi_socket_action.rst \
	doc/docstrings/multi_socket_all.rst \
	doc/docstrings/multi_timeout.rst \
	doc/docstrings/pycurl_global_cleanup.rst \
	doc/docstrings/pycurl_global_init.rst \
	doc/docstrings/pycurl_module.rst \
	doc/docstrings/pycurl_version_info.rst \
	doc/docstrings/share.rst \
	doc/docstrings/share_close.rst \
	doc/docstrings/share_setopt.rst

all: build
src-release: $(RELEASE_SOURCES)

src/docstrings.c src/docstrings.h: $(DOCSTRINGS_SOURCES)
	$(PYTHON) setup.py docstrings

src/allpycurl.c: $(ALL_SOURCES)
	echo '#define PYCURL_SINGLE_FILE' >src/.tmp.allpycurl.c
	cat src/pycurl.h >>src/.tmp.allpycurl.c
	cat src/docstrings.c $(SOURCES) |sed -e 's/#include "pycurl.h"//' -e 's/#include "docstrings.h"//' >>src/.tmp.allpycurl.c
	mv src/.tmp.allpycurl.c src/allpycurl.c

gen: $(ALL_SOURCES)

build: $(ALL_SOURCES)
	$(PYTHON) setup.py build

build-release: $(RELEASE_SOURCES)
	PYCURL_RELEASE=1 $(PYTHON) setup.py build

do-test:
	make -C tests/fake-curl/libcurl
	./tests/run.sh
	./tests/ext/test-suite.sh
	$(PYFLAKES) python examples tests setup.py

test: build do-test
test-release: build-release do-test

# rails-style alias
c: console
console:
	PYTHONPATH=$$(ls -d build/lib.*$$PYTHONMAJOR*$$PYTHONMINOR):$$PYTHONPATH \
	$(PYTHON)

# (needs GNU binutils)
strip: build
	strip -p --strip-unneeded build/lib*/*.so
	chmod -x build/lib*/*.so

install install_lib:
	$(PYTHON) setup.py $@

clean:
	-rm -rf build dist
	-rm -f *.pyc *.pyo */*.pyc */*.pyo */*/*.pyc */*/*.pyo
	-rm -f MANIFEST
	-rm -f src/allpycurl.c $(GEN_SOURCES)

distclean: clean

maintainer-clean: distclean

dist sdist: distclean
	$(PYTHON) setup.py sdist

run-quickstart:
	./tests/run-quickstart.sh

# Rebuild missing or changed documentation.
# Editing docstrings in Python or C source will not cause the documentation
# to be rebuilt with this target, use docs-force instead.
docs: build
	mkdir -p build/docstrings
	for file in doc/docstrings/*.rst; do tail -n +3 $$file >build/docstrings/`basename $$file`; done
	PYTHONPATH=$$(ls -d build/lib.*$$PYTHONMAJOR*$$PYTHONMINOR):$$PYTHONPATH \
	$(PYTHON) -m sphinx doc build/doc
	cp ChangeLog build/doc

# Rebuild all documentation.
# As sphinx extracts documentation from pycurl modules, docs targets
# depend on build target.
docs-force: build
	# sphinx-docs has an -a option but it does not seem to always
	# rebuild everything
	rm -rf build/doc
	PYTHONPATH=$$(ls -d build/lib.*$$PYTHONMAJOR*$$PYTHONMINOR):$$PYTHONPATH \
	$(PYTHON) -m sphinx doc build/doc
	cp ChangeLog build/doc

www: docs
	mkdir -p build
	rsync -a www build --delete
	rsync -a build/doc/ build/www/htdocs/doc --exclude .buildinfo --exclude .doctrees
	cp doc/static/favicon.ico build/www/htdocs
	cp ChangeLog build/www/htdocs

rsync: rsync-prepare
	cd $(BUILD_WWW) && \
	$(RSYNC) $(RSYNC_FLAGS) $(RSYNC_EXCLUDES) $(RSYNC_FILES) $(RSYNC_USER):$(RSYNC_TARGET)

rsync-dry:
	$(MAKE) rsync 'RSYNC=rsync --dry-run'

rsync-check:
	$(MAKE) rsync 'RSYNC=rsync --dry-run -c'

# NOTE: Git does not maintain metadata like owners and file permissions,
#       so we have to care manually.
# NOTE: rsync targets depend on www.
rsync-prepare:
	chgrp $(CHMOD_VERBOSE) -R pycurl $(BUILD_WWW)
	chmod $(CHMOD_VERBOSE) g+r `find $(BUILD_WWW) -perm +400 -print`
	chmod $(CHMOD_VERBOSE) g+w `find $(BUILD_WWW) -perm +200 -print`
	chmod $(CHMOD_VERBOSE) g+s `find $(BUILD_WWW) -type d -print`
##	chmod $(CHMOD_VERBOSE) g+rws `find $(BUILD_WWW) -type d -perm -770 -print`
	chmod $(CHMOD_VERBOSE) g+rws `find $(BUILD_WWW) -type d -print`
	chmod $(CHMOD_VERBOSE) o-rwx $(BUILD_WWW)/upload
	#-rm -rf `find $(BUILD_WWW) -name .xvpics -type d -print`

.PHONY: all build test do-test strip install install_lib \
	clean distclean maintainer-clean dist sdist \
	docs docs-force \
	rsync rsync-dry rsync-check rsync-prepare

.NOEXPORT:

=== tests/fake-curl/libcurl/Makefile ===
--- 
+++ 
@@ -21,8 +21,15 @@
 endif
 
 .c.so:
+
+#AIX linker don't support -soname flag
+ifeq ($(UNAME),AIX)
+	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -shared -fPIC \
+               -o $@ $<
+else
 	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -shared -fPIC \
 		-Wl,$(SONAME_FLAG),$@ -o $@ $<
+endif
 
 show-targets:
 	ls *c |sed -e 's/.c$$/.so/' | awk '{print $$1 " \\"}'

=== debian/changelog ===
pycurl (7.45.7-2) unstable; urgency=medium

  * Team upload.
  * d/p/skip_kerberos_tests_on_libcurl_8.17.0.patch: New patch to support curl
    >= 8.17.0

 -- Samuel Henrique <samueloph@debian.org>  Sun, 26 Oct 2025 12:30:02 +0000

pycurl (7.45.7-1) unstable; urgency=medium

  * Update to new upstream release 7.45.7
  * Switch to pybuild & pyproject build

 -- Scott Talbert <swt@techie.net>  Thu, 25 Sep 2025 15:11:09 -0400

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,6 @@
 
 include /usr/share/dpkg/architecture.mk
 
-PY3VERS := $(shell py3versions -vs)
 CURLVERS := $(strip $(shell /usr/bin/curl-config --version | awk '{print $$2}' | sed 's/-rc/~rc/'))
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -19,32 +18,21 @@
 export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__$(DEB_HOST_MULTIARCH)
 endif
 
+export no_proxy=localhost,127.0.0.1
+export PYBUILD_NAME=pycurl
+export PYBUILD_BEFORE_TEST=make -C tests/fake-curl/libcurl && mkdir -p tests/tmp
+export PYBUILD_TEST_ARGS=-v -ra -m 'not online'
+export PYCURL_VSFTPD_PATH=vsftpd
+
 %:
-	dh $@
+	dh $@ --buildsystem=pybuild
 
-override_dh_auto_build:
-	$(MAKE) gen PYTHON=python3
-	for py in $(PY3VERS) ; do \
-		python$$py setup.py build ; \
-	done
-	mkdir -p www/htdocs/doc
-ifneq (,$(filter python-pycurl-doc,$(DO_PACKAGES)))
+override_dh_auto_build-indep:
 	$(MAKE) docs PYTHON=python3
-endif
 
-override_dh_auto_test:
-ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
-	set -e ;\
-	for py in $(PY3VERS) ; do \
-		make do-test PYTHON=python$$py PYTEST="python$$py -m pytest" PYTEST_ADDOPTS="--ignore examples --ignore .pc -m 'not online'" PYFLAKES="python$$py -m pyflakes" PYCURL_VSFTPD_PATH=vsftpd; \
-	done
-endif
+override_dh_auto_test-indep:
 
-override_dh_auto_install:
-	for py in $(PY3VERS); do \
-		python$$py setup.py install --root=$(CURDIR)/debian/python3-pycurl --install-layout=deb; \
-	done
-
+execute_after_dh_auto_install-arch:
 	# Remove documentation as installed by setup.py
 	rm -rf $(CURDIR)/debian/python*-pycurl*/usr/share/doc/pycurl

=== debian/tests/control ===
Test-Command: python3 -c "import curl; print(curl.__file__)"

Tests: livetest.sh
Depends: build-essential,
         ca-certificates,
         libcurl4-gnutls-dev,
         python3-all,
         python3-flask,
         python3-flaky,
         python3-pyflakes,
         python3-pytest,
         python3-setuptools,
         vsftpd,
         @
Restrictions: allow-stderr
